/*
	ProWesS, PROGS Windowing System

	PWClose : routine to close the window of the system, and replace the gstate
			  (if any) by a info gstate.

	(c) PROGS, Professional & Graphical Software
	written by Joachim Van der Auwera
	started 9 June 1995
	15.04.1997 restore pointer pos when closing the window
*/

#include <mem.h>
#include <win.h>
#include <job.h>
#include <thing.h>

#include "private.h"
#include "PWHandler.h"

extern Bbox emptyBbox;

Error PWClose(PWSystem *system)
{
	Error err=ERR_OK;

	if (system->window!=WINDOW_NONE)
	{
		err=PFPGstateReAssign(system->gstate,PF_DRIVER_DUMMY,0,0,0,0);
		WINPointerPositionSet(system->window,system->oldptrx,system->oldptry);
		WINClose(system->window);
		system->window=WINDOW_NONE;
	}
	if (system->status&SSTATUS_BUTFRAME)
	{
		THINGFree("Button Frame");
		JOBPriority(MYSELF,system->priority);
	}
	return err;
}
