/*
	ProWesS, PROGS Windowing System

	PWGetType, get the type definition

	(c) PROGS, Professional & Graphical Software
	written by Joachim Van der Auwera
	started 5 May 1995
*/

#include "PWHandler.h"
#include "PWJob.h"

/* external symbols */
extern PWTypeDef *xtyp_list;		/* defined in ProWesS_c */

Error PWGetType(PWType type, PWTypeDef **rettype)
{
	Error err;
	PWJob *jobinfo;
	PWTypeDef *typedefn;

	/* search for the typedefinition */

	/* first see if there already is a PWJob */
	PWJobCreate(&jobinfo);

	/* scan through job specific types to find type */
	for ( typedefn=jobinfo->ltyp_list ;
		  typedefn && typedefn->identifier!=type ;
		  typedefn=(PWTypeDef *)typedefn->flag );
	if (!typedefn)
	{
		for ( typedefn=xtyp_list ;
			  typedefn && typedefn->identifier!=type ;
			  typedefn=(PWTypeDef *)typedefn->flag );
	}
	if (!typedefn) return ERR_IPAR;  /* unknown object type */

	*rettype=typedefn;
	return ERR_OK;
}
