/*
	ProWesS, PROGS Windowing System

	ProWesS file viewer test program

	(c) PROGS, Professional & Graphical Software
	written by Joachim Van der Auwera
	started 6 September 1995
*/

#include "ProWesS.h"

typedef struct {
	PWObject file,it;
	char *base; int length;
	} Global;

Error doload(PWObject object, char *dir, char *name)
{
	Channel ch;
	Global *g;
	Size size;
	Error err;

	PWQuery(object,PW_GLOBAL_AUXILIARY,&g);
	err=IOOpenPath(name,OPEN_READ,dir,&ch);
	if (err) return err;
	IOLength(ch,&size);
	size++;
	if (size>g->length)
	{
		if (g->base)
			MEMRelease(g->base);
		g->base=NULL; g->length=0;
		err=MEMAllocate(size,&g->base);
		if (err) return err;
		g->length=size;
	}
	size--;
	IOFileLoad(ch,size,g->base);
	g->base[size]='\0';
	IOClose(ch);
	return PWChange(g->it,PW_INFOTEXT_TEXT,g->base,NULL);
}

Error loadfile(PWObject object)
{
	Global *g;
	PWQuery(object,PW_GLOBAL_AUXILIARY,&g);
	return PWChange(g->file,PW_FILESELECT_ACTIVATE,NULL);
}

Error init()
{
	PWObject obj;
	Global g;
	Error err;

	g.base=NULL; g.length=0;
	err=PWCreate(NULL,&obj,PW_TYPE_OUTLINE,
				PW_OUTLINE_SLEEP,
				PW_OUTLINE_QUIT,
				PW_OUTLINE_QUIT_KEYPRESS, 27,
				PW_OUTLINE_INFO_TEXT, "Load file",
				PW_OUTLINE_ACTION_INFO, loadfile,
				PW_GLOBAL_AUXILIARY, &g,
				NULL);
	if (err) return err;
	err=PWCreate(obj,&g.it,PW_TYPE_INFOTEXT,
				PW_INFOTEXT_WIDTH_FS, short2pt(30),
				PW_INFOTEXT_LINES, 12,
				NULL);
	if (err) return err;
	err=PWCreate(obj,&g.file,PW_TYPE_FILESELECT,
				PW_KEYPRESS, 'l',
				PW_FILESELECT_ACTION, doload,
				NULL);
	if (err) return err;
	err=PWActivate(obj);
	return err;
}
